package cn.com.qmth.am.service.impl;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.qmth.boot.core.solar.model.OrgInfo;
import com.qmth.boot.core.solar.service.SolarService;

import cn.com.qmth.am.bean.OcrDto;
import cn.com.qmth.am.multithread.producer.LocalOcrProducer;
import cn.com.qmth.am.service.OcrService;

@Service
public class OcrServiceImpl implements OcrService {

    private static final Logger log = LoggerFactory.getLogger(OcrService.class);

    @Autowired
    private SolarService solarService;

    @Override
    public void ocr() {
        log.warn("OcrService ocr start*************");
        File dir = new File("d:/ocr/data");
        OrgInfo org = solarService.getOrgList().get(0);
        List<OcrDto> files = new ArrayList<>();
        disposeFile(files, dir, org);
        LocalOcrProducer producer = new LocalOcrProducer();
        Map<String, Object> param = new HashMap<>();
        param.put("files", files);
        producer.startDispose(4, param, files.size());
        while (true) {
            List<OcrDto> failed = producer.getFaildDto();
            if (CollectionUtils.isEmpty(failed)) {
                break;
            }
            param = new HashMap<>();
            param.put("files", failed);
            producer = new LocalOcrProducer();
            producer.startDispose(4, param, failed.size());
        }
        log.warn("OcrService ocr finish*************");
    }

    private void disposeFile(List<OcrDto> files, File file, OrgInfo org) {
        if (file.isFile() && file.getName().toLowerCase().endsWith(".jpg")) {
            files.add(new OcrDto(file, org));
        } else {
            if (file.isDirectory()) {
                for (File subFile : file.listFiles()) {
                    disposeFile(files, subFile, org);
                }
            }
        }
    }

}